<script setup lang="ts">
import { ref, type PropType } from 'vue'

export interface FakeData {
  value: number
  name: string
}

const props = defineProps({
  modelValue: {
    type: Object as PropType<FakeData | null>,
    default: null
  },
  selectListData: {
    type: Array as PropType<FakeData[]>,
    required: true
  }
})

const emit = defineEmits<{
  (event: 'update:modelValue', value: { value: number; name: string }): void
}>()

const inputValue = ref('')
const isActive = ref(false)

const selectList = computed(() =>
  inputValue.value !== ''
    ? props.selectListData.filter((item) =>
        item.name.includes(inputValue.value)
      )
    : props.selectListData
)

function removeStyle() {
  document.querySelector('.dropdown-menu')?.classList.remove('show')
}
</script>

<template>
  <button
    id="dropdown"
    :class="{ placeholder: !modelValue?.name }"
    :value="modelValue?.value"
    aria-expanded="false"
    class="default-select font-zh-p-medium form-control"
    data-bs-toggle="dropdown"
    position="left"
    type="button"
    @click="isActive = !isActive"
    @focusout="isActive = false"
  >
    {{ modelValue?.name ?? '請選擇' }}
    <div
      :class="{ 'not-active': !isActive }"
      class="icon-arrow-down-gray"
    ></div>
  </button>
  <div aria-labelledby="dropdown" class="select-menu dropdown-menu">
    <div class="input-item">
      <input
        v-model="inputValue"
        class="dropdown-search font-zh-p-medium form-control"
        placeholder="請輸入"
        type="text"
      />
      <div class="icon-search-gray"></div>
    </div>
    <ul class="dropdown-items">
      <li v-for="item of selectList" :key="item.value">
        <a
          class="font-en-small-regular font-zh-small-regular dropdown-item"
          href="#"
          @click="emit('update:modelValue', item), removeStyle()"
        >
          {{ item.name }}</a
        >
      </li>
    </ul>
  </div>
</template>

<style lang="scss" scoped></style>
